#include <algorithm>
#include <iostream>
#include <map>
#include <stack>
#include <string>
#include <vector>
using namespace std;

int calc(string &str) {
	map<char, int> left, right;
	int N = str.size();

	for(char c = 'a'; c <= 'z'; c++) {
		left[c] = 0;
		right[c] = 0;
	}

	for(int i = 0; i < N / 2; i++) {
		left[ str[i] ] = left[ str[i] ] + 1;
		right[ str[N / 2 + i] ] = right[ str[N / 2 + i] ] + 1;
	}

	// Check for even split
	bool even = true;
	for(char c = 'a'; c <= 'z'; c++) {
		even &= left[c] == right[c];
	}

	if(even) {
		int center = 0;
		for(int i = 0; i < N / 2; i++) {
			if(str[N / 2 - 1 - i] != str[N / 2 + i]) break;
			center++;
		}
		return N / 2 - center;
	}

	int take = 0;
	map<char, int> total;
	for(char c = 'a'; c <= 'z'; c++) {
		total[c] = left[c] + right[c];
	}
	while(total[ str[take] ] > 0) {
		total[ str[take] ] -= 2;
		take++;
	}

	return N - take;
}

/**
 * Lessons
 *  - String preprocessing
 *  - Palindromes
 *  - Map from char to int
 *  - Two fully disjoint cases handled separately
 */
int main() {

	int T;
	cin >> T;
	for(int test = 0; test < T; test++) {
		string s;
		cin >> s;
		int safe = 0;
		int N = s.length();
		while(s[safe] == s[N - safe - 1] && safe < N) safe++;
		if(safe == N) {
			cout << "0\n";
			continue;
		}
	
		string mid = s.substr(safe, N - 2 * safe);
		string rev = mid.substr();
		for(int i = 0; i < rev.length(); i++) {
			rev[i] = mid[mid.length() - 1 - i];
		}
		cout << min(calc(mid), calc(rev)) << '\n';
	}

	return 0;
}

